#!/bin/bash
# last change in 20221019

SHELL_DIR=$(dirname $(readlink -f "$0"))
LOG_DIR="/var/log/general_check"
LOG_FILE="${LOG_DIR}/generalcheck.log"
time_when_save_all=20      # save all logfiles in lastest N days
every_time_for_save_one=1  # only save 1 logfile every N days 
time_when_save_one=20      # 

Log_Clean()
{
    current_time=`date +"%Y%m%d"`
    for ((circle=0 ; circle <= ${time_when_save_one} ; circle++))
    do
        # echo "${circle}" >> ${LOG_FILE}
        check_day=$((time_when_save_all+every_time_for_save_one*circle))
        # echo "${check_day}" >> ${LOG_FILE}
        time=`date +"%Y%m%d" -d -${check_day}days`
        # echo "${time}" >> ${LOG_FILE}
        if [ "${circle}" -ne "${time_when_save_one}" ]
        then
            checklog=(`find /var/log/general_check/${time}*check_log.tar.gz -type f 2>/dev/null`)
            alarmlog=(`find /var/log/general_check/${time}*alarm_log.log    -type f 2>/dev/null`)
            for ((n=${#checklog[@]}-2 ; n >=0 ; n--))
            do
                # echo "delete : ${checklog[n]}" >> ${LOG_FILE}
                /bin/rm -rf ${checklog[n]}
            done
            for ((n=${#alarmlog[@]}-2 ; n >=0 ; n--))
            do
                # echo "delete : ${alarmlog[n]}" >> ${LOG_FILE}
                /bin/rm -rf ${alarmlog[n]}
            done
            checklog=("")
            alarmlog=("")
        else
            find /var/log/general_check/${time}*check_log.tar.gz -type f 2>/dev/null | xargs /bin/rm -rf
            find /var/log/general_check/${time}*alarm_log.log    -type f 2>/dev/null | xargs /bin/rm -rf
            break
        fi
    done
}

###########################################
[ ! -d "${LOG_DIR}" ] && mkdir -p ${LOG_DIR}
if [ -f "${LOG_FILE}" ]
then
    logsize=`du -shk ${LOG_FILE} | awk -F' ' '{print $1}'`
    # echo "${logsize}" >> ${LOG_FILE}
    if [ "${logsize}" -gt "1000" ]
    then
        logline=`wc -l ${LOG_FILE} | awk -F' ' '{print $1}'`
        mid=$((logline/2))
        # echo "${mid}" >> ${LOG_FILE}
        sed -i "1,${mid}d" ${LOG_FILE}
    fi
fi
Log_Clean
cat >> ${LOG_FILE} << EOF

*******************************************
check begin at `date`

EOF
# $1 : IP&PSW file
/bin/sh ${SHELL_DIR}/GeneralCheck.sh -f $1 -t >> ${LOG_FILE}
cat >> ${LOG_FILE} << EOF

check end at `date`
*******************************************

EOF

